<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Accounts' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div>
      <div class="top">
        <b-row>
          <b-col class="left-col">
            <span>
              <img
                src="@/assets/icons/face_user.svg"
                alt="Icône utilisateurs"
              />
              {{ usersCount }} utilisateurs
            </span>
            <div
              class="add-btn"
              @click="$router.push({ name: 'AddUser' })"
            >
              <b-icon-plus />
              Ajouter un utilisateur
            </div>
            <SearchTable
              :placeholder="'Rechercher un utilisateur'"
              :searchFunction="SEARCH_USERS_LIST"
              @loading="loadSearch"
            />
          </b-col>
          <b-col class="right-col">
            <TableFilters
              :filter-name="'status__in'"
              @filter="setTableFilters"
            />
          </b-col>
        </b-row>
      </div>
      <div class="custom-table">
        <b-overlay
          :show="loading"
          :variant="'white'"
          :opacity="0.7"
          rounded="sm"
        >
          <template #overlay>
            <div class="d-flex align-items-center">
              <b-spinner variant="secondary"></b-spinner>
            </div>
          </template>
          <CustomTable
            :routeTo="'UserDetail'"
            :fields="fields"
            :items="items"
            :defaultSorting="{
              sortedUp: false,
              sortedDown: true,
              sortedField: 'date_joined'
            }"
            :sortFunction="GET_USERS_LIST"
            :selectable="false"
            @sorted="setTableSorted"
            @delete="openDeleteModal"
            @loading="setTableLoader"
          />
          <Pagination
            v-if="usersCount > 50"
            :nbPages="Math.ceil(usersCount/50)"
            @change-page="changeTablePage"
          />
        </b-overlay>
      </div>
    </div>
    <DeleteUser
      :open="deletingUser"
      :user="userToDelete"
      @hide="deletingUser = false"
      @update="updateUsersList"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import SearchTable from '@/components/SearchTable.vue';
import DeleteUser from '@/components/Modals/DeleteUser.vue';
import TableFilters from '@/components/TableFilters.vue';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'Users',

  components: {
    CustomTable,
    Pagination,
    SearchTable,
    DeleteUser,
    TableFilters
  },

  data() {
    return {
      loading: false,
      addingUser: false,
      deletingUser: false,
      userToDelete: null,
      fields: [
        {
          key: 'Nom',
          apiName: 'last_name',
          sortable: true,
          width: '9%'
        },
        {
          key: 'Prénom',
          apiName: 'first_name',
          sortable: true,
          width: '9%'
        },
        {
          key: 'Identifiant',
          apiName: 'username',
          sortable: true,
          width: '10%'
        },
        {
          key: 'Organisation',
          sortable: false,
          width: '12%'
        },
        {
          key: 'Date d\'inscription',
          apiName: 'date_joined',
          sortable: true,
          width: '15%'
        },
        {
          key: 'Dernière connexion',
          apiName: 'last_login',
          sortable: true,
          width: '16%'
        },
        {
          key: 'Statut',
          sortable: false,
          width: '6%'
        },
        {
          key: 'Admin',
          sortable: false,
          width: '6%'
        },
        {
          key: 'Supprimer',
          sortable: false,
          width: '8%'
        }
      ],
      tableSorted: {
        direction: '-',
        field: 'date_joined'
      }
    };
  },

  computed: {
    ...mapState('users', [
      'usersList',
      'usersCount',
      'isUsersListSearched',
      'searchUsersFilter'
    ]),
    ...mapState('organisations', ['organisationsList']),
    ...mapState('usergroups', ['usergroupsRoles']),
    items() {
      return this.usersList.map(el => {
        return {
          id: el.id,
          'Nom': el.last_name.toUpperCase(),
          'Prénom': el.first_name,
          'Identifiant': el.username,
          'Organisation': el.usergroup_roles.map(usergroupEl => usergroupEl.usergroup.display_name).join(', '),
          'Date d\'inscription':
            el.date_joined ? new Date(el.date_joined).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}) : '',
          'Dernière connexion':
          el.last_login ? new Date(el.last_login).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}) : '',
          'Statut': [
            {choice: 0, value: 'secondary'},
            {choice: 1, value: 'warning'},
            {choice: 2, value: 'success'}
          ].find(item => item.choice === el.status).value,
          'Admin': el.is_superuser
        }
      });
    }
  },

  created() {
    // Reset filters
    this.setTableFilters({
      filter: 'status__in',
      values: [
        {status: '2', state: true},
        {status: '1', state: false},
        {status: '0', state: false}
      ]
    })
    // Get data if data not loaded already
    if (this.usergroupsRoles.length === 0) {
      this.getConfigData();
    }
    if (this.usersList.length === 0 || this.isUsersListSearched) {
      this.getData();
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.addingUser = false;
      this.deletingUser = false
    });
  },

  methods: {
    ...mapActions('users', [
      'GET_USERS_LIST',
      'SEARCH_USERS_LIST',
      'PRESET_USERS_FILTERS',
      'PREREMOVE_USERS_FILTERS'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST',
      'GET_ORGANISATIONS_TYPES'
    ]),
    ...mapActions('usergroups', [
      'GET_USERGROUPS_ROLES'
    ]),

    getConfigData() {
      this.GET_ORGANISATIONS_TYPES();
      this.GET_USERGROUPS_ROLES();
    },

    getData() {
      this.loading = true;
      Promise.all([
        this.GET_USERS_LIST({...this.tableSorted}),
        this.GET_ORGANISATIONS_LIST({...this.tableSorted})
      ]).then(() => {
        this.loading = false;
      });
    },

    openDeleteModal(e) {
      this.deletingUser = true;
      this.userToDelete = e;
    },

    updateUsersList() {
      this.getData();
    },

    changeTablePage(e) {
      this.loading = true;
      this.GET_USERS_LIST({...this.tableSorted, page: e}).then(() => {
        this.loading = false;
      });
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    loadSearch(e) {
      this.loading = e;
    },

    setTableFilters(e) {
      for (const filter of e.values) {
        if (filter.state) {
          this.PRESET_USERS_FILTERS({
            filter: e.filter,
            value: filter.status
          });
        } else {
          this.PREREMOVE_USERS_FILTERS({
            filter: e.filter,
            value: filter.status
          });
        }
      }
      this.loading = true;
      if (!this.isUsersListSearched) {
        this.GET_USERS_LIST({...this.tableSorted})
        .then(() => {
          this.loading = false;
        });
      } else {
        this.SEARCH_USERS_LIST({
          text: this.searchUsersFilter,
          ordering: {...this.tableSorted}
        })
        .then(() => {
          this.loading = false;
        });
      }
    }
  }
}
</script>

<style lang="less" scoped>

.b-overlay {
  .position-absolute {
    display: flex;
  }
}

</style>
